<template>

  <div>


    <el-card class="box-card">
      <!-- 搜索区域 -->
      <div class="search-bx1">
          <el-input v-model="searchData.number" placeholder="饲喂车编号"  style="width: 220px;" class="g-mr20" clearable />
          <el-input v-model="searchData.name" placeholder="饲喂车名称"  style="width: 220px;" class="g-mr20" clearable />
          <el-input-number v-model="searchData.min_capacity" style="width:120px;" :controls="false" placeholder="载量" />
          <span style="margin:0px 8px;">至</span>
          <el-input-number v-model="searchData.max_capacity" style="width:120px;" class="g-mr20" :controls="false" placeholder="载量" />

          <el-button type="primary"   @click="form_search">搜索</el-button>
          <el-button type="primary"   @click="form_clear">重置</el-button>
          <el-button type="primary" v-if="isButtonEdit"   @click="form_add">添加</el-button>
           <!-- <el-button type="primary"   @click="form_export">导出</el-button> -->
      </div>


      <!-- 表格 -->
      <el-table   key="0"  :data="tableList"  v-loading="tableLoading" element-loading-text="给我一点时间"    border fit>
        <el-table-column label="序号"  width="50px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.id }}</span>
          </template>
        </el-table-column>
        <el-table-column label="饲喂车编号" min-width="150px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.number }}</span>
          </template>
        </el-table-column>
        <el-table-column label="饲喂车名称" min-width="150px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.name }}</span>
          </template>
        </el-table-column>
        <el-table-column label="容量(kg)" min-width="150px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.capacity }}</span>
          </template>
        </el-table-column>

        <el-table-column label="装车记录" align="center" width="300" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="scope">
             <el-button type="primary" size="mini" icon="el-icon-edit" @click="form_record_see(scope.row)">查看</el-button>
          </template>
        </el-table-column>

        <!-- <el-table-column  label="状态"  min-width="100px" align="center">
          <template slot-scope="scope">
            <el-switch v-model="scope.row.mg_state" active-color="#13ce66" inactive-color="#ff4949" :active-value="1" :inactive-value="0"   />
          </template>
        </el-table-column> -->

        <el-table-column label="操作" align="center" width="300" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="scope">
             <!-- 修改按钮 -->
             <el-button type="primary" v-if="isButtonEdit"  size="mini" icon="el-icon-edit" @click="form_edit(scope.row)">修改</el-button>
             <!-- 删除按钮 -->
             <el-button type="danger" v-if="isButtonEdit" size="mini" icon="el-icon-delete" @click="form_delete(scope.row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <!-- 分页区域 -->
      <el-pagination  @size-change="change_size_page"  @current-change="change_current_page"  :current-page="searchData.page" :page-sizes="[1,5,10,20,30,50]"  :page-size="searchData.page_size" layout="total, prev, pager, next" :total="searchData.total"/>
    </el-card>


    <!-- 弹窗 新增or修改 -->
    <el-dialog  :title="addFormTxt[addFormStatus]" :visible.sync="addFormShow" @close="add_dialog_close" width="50%">
      <div class="">
        <el-form  ref="addFormRef"  :rules="addFormRules"  :model="addForm"  label-position="right" label-width="140px"  style="width:50%;margin:0 auto 50px">
            <el-form-item label="饲喂车编号：" prop="number">
                <el-input   v-model="addForm.number" :disabled="addFormStatus=='edit'"  ></el-input>
            </el-form-item>
            <el-form-item label="饲喂车名称：" prop="name">
                <el-input   v-model="addForm.name"  ></el-input>
            </el-form-item>
            <el-form-item label="容量(kg)：" prop="capacity">
                <el-input   v-model="addForm.capacity"  ></el-input>
            </el-form-item>


        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button type="primary" @click="addFormStatus==='create'?add_dialog_save():edit_dialog_save()">确认</el-button>
          <el-button @click="addFormShow = false">关闭</el-button>
        </div>
      </div>
    </el-dialog>


    <el-dialog  :title="addFormTxt[addFormStatus]" :visible.sync="seeFormShow" @close="see_dialog_close" width="80%">
      <div class="">
        <div class="search-bx1">
          <el-date-picker v-model="searchData2.inputDatetime" type="daterange"   range-separator="至" start-placeholder="装车时间" end-placeholder="装车时间"  class="g-mr20" />
          <el-select v-model="searchData2.calf_category_id" filterable placeholder="犊牛类型"   style="width: 150px;" clearable  class="g-mr20" >
            <el-option v-for="item in calfTypeList" :key="item.id" :label="item.name" :value="item.id" />
          </el-select>
          <el-input v-model="searchData2.name" placeholder="配方名称" style="width: 180px;"  class="g-mr20"  clearable />
          <el-button type="primary"   @click="form_search2">搜索</el-button>
        </div>


        <el-table   key="0"  :data="tableList2"  v-loading="tableLoading2" element-loading-text="给我一点时间"    border fit>
          <el-table-column label="序号"  width="50px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.id }}</span>
            </template>
          </el-table-column>
          <el-table-column label="装车时间" min-width="150px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.created_at_format }}</span>
            </template>
          </el-table-column>
          <el-table-column label="犊牛类型" min-width="150px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.calf_category_name }}</span>
            </template>
          </el-table-column>
          <el-table-column label="配方名称" min-width="150px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.formula_name }}</span>
            </template>
          </el-table-column>
          <el-table-column label="装车量(kg)" min-width="150px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.capacity }}</span>
            </template>
          </el-table-column>



        </el-table>

        <!-- 分页区域 -->
        <el-pagination  @size-change="change_size_page2"  @current-change="change_current_page2"  :current-page="searchData2.page" :page-sizes="[1,5,10,20,30,50]"  :page-size="searchData2.page_size" layout="total, prev, pager, next" :total="searchData2.total"/>


        <div slot="footer" class="dialog-footer">
          <el-button @click="seeFormShow = false">关闭</el-button>
        </div>
      </div>
    </el-dialog>



  </div>


</template>

<script>
import {  ajaxDataGet, ajaxDataPost, ajaxDataPut, ajaxDataDelete, checkButtons} from '@/api/common'
import { parseTime, json2excel } from '@/utils/index.js'

export default {
  data() {





    return {



      //接口 - 获取 - 表格
      url_get_table:'/api/v1/ops/base_setting/feed_vehicle/list',
      //接口 - 新增 - 表格
      url_add_table:'/api/v1/ops/base_setting/feed_vehicle/add',
      //接口 - 修改 - 表格
      url_edit_table:'/api/v1/ops/base_setting/feed_vehicle/update',
      //接口 - 删除 - 表格
      url_delete_table:'/api/v1/ops/base_setting/feed_vehicle/is_show',

      //接口 - 获取 - 弹窗里表格
      url_get_table2:'/api/v1/ops/base_setting/feed_vehicle/logs',

      //接口 - 下拉框 列表
      url_get_select1:'/role/getAll',

      //按钮权限
      isButtonEdit:false,

      //获取 - 表格数据 - 参数
      searchData:{
        name: "",
        number: "",
        min_capacity: undefined,
        max_capacity: undefined,
        page: 1,  //页码
        page_size: 10,   //每页数量
        total:0,  //总页数
        pastureId: ""
      },
      tableLoading: false,
      //表格内容
      tableList:[
           { username:"admin", id:100, date:'2023-12-01',email:'测试信息1123',roleList:[2,3] },
         { username:"epans", id:200, date:'2023-12-01',email:'测试信息1123',roleList:[] },
        // { username:"derek", id:300, date:'2023-12-01',email:'测试信息1123' },
        // { username:"admin", id:100, date:'2023-12-01',email:'测试信息1123' },
        // { username:"epans", id:200, date:'2023-12-01',email:'测试信息1123' },
        // { username:"derek", id:300, date:'2023-12-01',email:'测试信息1123' },
        // { username:"admin", id:100, date:'2023-12-01',email:'测试信息1123' },
        // { username:"epans", id:200, date:'2023-12-01',email:'测试信息1123' },
        // { username:"derek", id:300, date:'2023-12-01',email:'测试信息1123' },
        // { username:"admin", id:100, date:'2023-12-01',email:'测试信息1123' },
        // { username:"epans", id:200, date:'2023-12-01',email:'测试信息1123' },
        // { username:"derek", id:300, date:'2023-12-01',email:'测试信息1123' },
      ],


      //犊牛类型下拉框
      calfTypeList:[

      ],

      searchData2:{
        start_time: parseTime(new Date(), '{y}-{m}-{d}'),
        end_time: parseTime(new Date(), '{y}-{m}-{d}'),
        inputDatetime: [new Date(), new Date()],
        name: "",
        calf_category_id: undefined,
        feed_vehicle_id: undefined,
        page: 1,  //页码
        page_size: 10,   //每页数量
        total:0,  //总页数
        pastureId: ""
      },
      tableLoading2: false,
      //表格内容
      tableList2:[
        //  { username:"admin", id:100, date:'2023-12-01',email:'测试信息1123',roleList:[2,3] },
        // { username:"epans", id:200, date:'2023-12-01',email:'测试信息1123',roleList:[] },
        // { username:"derek", id:300, date:'2023-12-01',email:'测试信息1123' },
        // { username:"admin", id:100, date:'2023-12-01',email:'测试信息1123' },
        // { username:"epans", id:200, date:'2023-12-01',email:'测试信息1123' },
        // { username:"derek", id:300, date:'2023-12-01',email:'测试信息1123' },
        // { username:"admin", id:100, date:'2023-12-01',email:'测试信息1123' },
        // { username:"epans", id:200, date:'2023-12-01',email:'测试信息1123' },
        // { username:"derek", id:300, date:'2023-12-01',email:'测试信息1123' },
        // { username:"admin", id:100, date:'2023-12-01',email:'测试信息1123' },
        // { username:"epans", id:200, date:'2023-12-01',email:'测试信息1123' },
        // { username:"derek", id:300, date:'2023-12-01',email:'测试信息1123' },
      ],







      addFormShow:false,
      addFormStatus: '',
      addFormTxt: {  edit: '修改',  create: '新增' },
      addForm:{
        name:'',number:'' ,capacity:'' ,id:''
      },

      addFormRules:{
        name: [ { required: true, message: '饲喂车名称必填', trigger: 'blur' },  ],
        number: [ { required: true, message: '饲喂车编号必填', trigger: 'blur' },  ],
        capacity: [ { required: true, message: '容量必填', trigger: 'blur' },  ],

      },


      seeFormShow:false,
      seeFormStatus: '',
      seeFormTxt: {  edit: '修改',  create: '新增' },
      seeForm:{
        name:'',id:''
      },



    }
  },
  created(){
      //获取按钮权限
      const isButtonEdit = checkButtons(this.$store.state.buttonsList, "饲喂车管理编辑")
      this.isButtonEdit = isButtonEdit
      console.log('this.isButtonEdit==========',this.isButtonEdit)


     //获取下拉框
     this.get_select_list1()

      //表格 - 初始化
     this.get_table_data()




  },
  methods:{

   

    //获取 下拉框
    get_select_list1(){
        var me = this


        var send_url = '/api/v1/ops/base_setting/calf_type/list?page=1&page_size=1000'


        ajaxDataPost(send_url,  {"name": "" }).then(e => {
          console.log("下拉框1：",e.data.list)

          //打印请求成功结果
          if(e.data.list == null || e.data.list == undefined ||e.data.list.length == 0   ){
            me.calfTypeList = []
          } else {
            me.calfTypeList = e.data.list
          }



        })


        // ajaxDataGet('/authdata/pasture', {  "page": 1,   "page_size": 1000}).then(e => {
        //   console.log("牧场下拉框1：",e)

        //   //打印请求成功结果
        //   if(e.data == null || e.data == undefined ||e.data.length == 0   ){
        //     me.pastureList = []
        //   } else {
        //     me.pastureList = e.data
        //   }

        // })


    },


    //获取 表格
    get_table_data() {

     var me = this

     me.tableLoading = true
     console.log("searchData======>", me.searchData)

      var send_url = me.url_get_table + '?page=' + me.searchData.page +  '&page_size=' + me.searchData.page_size

      ajaxDataPost(send_url,  me.searchData).then(e => {
        console.log("表格请求结果：",e)
          //打印请求成功结果
          if(e.code == 200 ){
            me.tableList = e.data.list
            me.searchData.total = e.data.total;	// 总数
            me.searchData.page = e.data.page;	//页码
            me.searchData.page_size = e.data.page_size;	//每页数量

          } else {
            me.$message({ type: 'error', message: '请求表格列表失败！' + e.msg, duration: 2000 })
          }

          setTimeout(() => {
            me.tableLoading = false
          }, 100)

        })


    },
    //搜索 查询表格
    form_search(){
      var me = this
      console.log('请求表格列表searchData',me.searchData)
      me.get_table_data()

    },

    //重置 表格
    form_clear(){
      var me = this
      me.searchData.name = ""
      me.searchData.number = ""
      me.searchData.min_capacity = undefined
      me.searchData.max_capacity = undefined
      me.searchData.pastureId = ""


      me.get_table_data()
    },

    //监听 page_size 改变的事件
    change_size_page(item){
      console.log(item)
     // this.searchData.page_size = item
      //  this.getUserList()
    },

    //监听 page 改变的事件
    change_current_page(item){
      console.log(item)
       this.searchData.page = item
       this.get_table_data()
    },

    //清空弹窗表单信息
    reset_form(){
      this.addForm.name = ''
      this.addForm.number = ''
      this.addForm.capacity = ''
      this.addForm.id = ''


    },

    //新增
    form_add() {
      this.reset_form()
      this.addFormStatus = 'create'
      this.addFormShow = true
      this.$nextTick(() => {
        this.$refs['addFormRef'].clearValidate()
      })
    },

    //编辑
    form_edit(row) {
      console.log('行内容row=========', row)
      //编辑行内容赋值
      this.addForm = Object.assign({}, row)
      this.addFormStatus = 'edit'
      this.addFormShow = true
      this.$nextTick(() => {
        this.$refs['addFormRef'].clearValidate()
      })
    },


    //新增关闭
    add_dialog_close(){
       //内容重置
       this.$refs['addFormRef'].resetFields()
    },

    //新增 保存
    add_dialog_save() {
      var me = this
      this.$refs['addFormRef'].validate(valid => {
        //验证成功
        if (valid) {
          //发起请求


          var send_data = {
              "name": me.addForm.name,
              "number": me.addForm.number,
              "capacity": parseFloat(me.addForm.capacity),

          }
          console.log("弹窗参数：", send_data)

          //关闭弹窗
          // me.addFormShow = false
         //加载 - 发送新增保存
           ajaxDataPost(me.url_add_table, send_data).then(e => {
                console.log("新增结果：",e)
                //打印请求成功结果
                if(e.code == 200  ){
                  me.$message({ type: 'success', message: '新增成功！'  , duration: 2000 })
                  //关闭弹窗
                  me.addFormShow = false
                  me.get_table_data()
                } else {
                  me.$message({ type: 'error', message: '新增失败！' + e.msg, duration: 2000 })
                }
            })

        }
      })
    },
    //编辑 保存
    edit_dialog_save(){
      var me = this
      this.$refs['addFormRef'].validate(valid => {
        //验证成功
        if (valid) {
          //发起请求
          var send_data = {
              "name": me.addForm.name,
              "number": me.addForm.number,
              "capacity": me.addForm.capacity,
              "id": me.addForm.id,
          }
          console.log("弹窗参数：", send_data)

          //关闭弹窗
          // me.addFormShow = false
         //加载 - 发送新增保存
         ajaxDataPut(me.url_edit_table, send_data).then(e => {
                console.log("编辑结果：",e)
                //打印请求成功结果
                if(e.code == 200  ){
                  me.$message({ type: 'success', message: '编辑成功！'  , duration: 2000 })
                  //关闭弹窗
                  me.addFormShow = false
                  me.get_table_data()
                } else {
                  me.$message({ type: 'error', message: '编辑失败！' + e.msg, duration: 2000 })
                }
            })

        }
      })
    },






    form_delete(row) {
      var me = this

       me.$confirm('是否删除此条内容?', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
       }).then(() => {
            console.log("删除的ID参数：", row.id)
            //加载 - 发送新增保存
            ajaxDataDelete(me.url_delete_table + '/' +row.id, {}).then(e => {
                console.log("编辑结果：",e)
                //打印请求成功结果
                if(e.code == 200  ){
                  me.$message({ type: 'success',  message: '删除成功!'  });
                  me.get_table_data()
                } else {
                  me.$message({ type: 'error', message: '删除失败！' + e.msg, duration: 2000 })
                }
            })




       }).catch(() => {
          me.$message({
            type: 'info',
            message: '已取消删除'
          });
       });



    },


    form_record_see(row) {
      console.log('行内容row=========', row)
      //编辑行内容赋值
      this.seeForm = Object.assign({}, row)
      this.searchData2.feed_vehicle_id = row.id
      this.get_table_data2()
      this.seeFormShow = true

    },

     //新增关闭
     see_dialog_close(){
       //内容重置
       this.seeFormShow = false
     },


    //获取 表格
    get_table_data2() {
      var me = this
      me.tableLoading2 = true
      console.log("searchData2======>", me.searchData2)
      var send_url = me.url_get_table2 + '?page=' + me.searchData2.page +  '&page_size=' + me.searchData2.page_size

      ajaxDataPost(send_url,  me.searchData2).then(e => {
        console.log("表格请求结果：",e)
          //打印请求成功结果
          if(e.code == 200 ){
            me.tableList2 = e.data.list
            me.searchData2.total = e.data.total;	// 总数
            me.searchData2.page = e.data.page;	//页码
            me.searchData2.page_size = e.data.page_size;	//每页数量

          } else {
            me.$message({ type: 'error', message: '请求表格列表失败！' + e.msg, duration: 2000 })
          }

          setTimeout(() => {
            me.tableLoading2 = false
          }, 100)

        })


    },
    //搜索 查询表格
    form_search2(){
      var me = this

      console.log(me.searchData2.inputDatetime[0])

      var time1 = Date.parse(new Date())
      console.log(time1)


      if (me.searchData2.inputDatetime !== '' && me.searchData2.inputDatetime !== null) {
          me.searchData2.start_time = parseTime(me.searchData2.inputDatetime[0], '{y}-{m}-{d}')
          me.searchData2.end_time = parseTime(me.searchData2.inputDatetime[1], '{y}-{m}-{d}')
        } else {
          me.searchData2.inputDatetime = ''
          me.searchData2.start_time = ''
          me.searchData2.end_time = ''
        }

      console.log('请求表格列表searchData2',me.searchData2)
      me.get_table_data2()

    },

    //重置 表格
    form_clear2(){
      var me = this
      me.searchData2.name = ""
      me.get_table_data2()
    },

    //监听 page_size 改变的事件
    change_size_page2(item){
      console.log(item)
    // this.searchData.page_size = item
      //  this.getUserList()
    },

    //监听 page 改变的事件
    change_current_page2(item){
      console.log(item)
      this.searchData2.page = item
      this.get_table_data2()
    },


    form_export() {
    //获取请求表格数据的参数
    //this.download.getdataListParm.parammaps = this.tableObj.getdataListParm.parammaps
    //请求表格
    // GetDataByName(this.download.getdataListParm).then(response => {
    //     if (response.data.list !== null) {
    //       this.download.list = response.data.list
    //     } else {
    //       this.download.list = []
    //     }
    //     var excelDatas = [
    //       {
    //         tHeader: ['表头1', '表头2', '表头3', '表头4',],
    //         filterVal: ['title1', 'title2', 'title3', 'title4'],
    //         tableDatas: this.download.list,
    //         sheetName: 'Sheet1'
    //       }
    //     ]
    //     json2excel(excelDatas, '表格大标题', true, 'xlsx')
    // })

    var excelDatas = [
        {
            tHeader: ['表头1', '表头2', '表头3', '表头4',],
            filterVal: ['title1', 'title2', 'title3', 'title4'],
            tableDatas: [
                {title1: "内容1",title2: "内容2",title3: "内容3",title4: "内容4"},
                {title1: "内容11",title2: "内容22",title3: "内容32",title4: "内容44"},
                {title1: "内容111",title2: "内容222",title3: "内容333",title4: "内容444"},
            ],
            sheetName: 'Sheet1'
        }
    ]
    json2excel(excelDatas, '表格大标题', true, 'xlsx')
}



  }
}
</script>
<!-- 加了scoped，则是仅在此组件里生效 -->
<style scoped>

</style>
